#ifndef GENERALSIMSETTINGS_H
#define GENERALSIMSETTINGS_H

#include <QJsonObject>
#include <QJsonArray>
#include <QString>

class GeneralSimSettings
{
public:
  GeneralSimSettings();
  ~GeneralSimSettings() {} //if (SecScintThetaHist) delete SecScintThetaHist;

  bool   fTimeResolved;
  double TimeFrom;
  double TimeTo;
  int    TimeBins;

  bool   fWaveResolved;
  double WaveFrom;
  double WaveTo;
  double WaveStep;
  int    WaveNodes;

  bool   fAreaResolved;
  bool   fAngResolved;
  int    CosBins;

  bool   fUseGains;
  bool   fUseElNoise;
  bool   fUseADCs;

  double MinStep;
  double MaxStep;
  double dE;
  double MinEnergy;
  double Safety;
  int    TrackColorAdd;

  int    MaxNumTrans;
  bool   fTracksOnPMsOnly;
  bool   fQEaccelerator;
  bool   fLogsStat; //generate logs and statistics of detected photons
  int    NumThreads;

  int    DetStatNumBins; //number of bins in fetection statistics

  int    SecScintGenMode;
  //TH1D *SecScintThetaHist;

  bool   fBuildPhotonTracks;

  //utility
  QString ErrorString;

  bool readFromJson(QJsonObject &Json);
};


#endif // GENERALSIMSETTINGS_H
