#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "genericscriptwindowclass.h"
#include "detectorclass.h"
#include "eventsdataclass.h"
#include "globalsettingsclass.h"
#include "interfacetoglobscript.h"
#include "scriptminimizer.h"
#include "scriptinterfaces.h"
#include "interfacetocheckerscript.h"

#include <QtGui>

void MainWindow::on_actionGlobal_script_triggered()
{
  extractGeometryOfScriptWindow();
  if (GenScriptWindow) delete GenScriptWindow;
  GenScriptWindow = new GenericScriptWindowClass();
  recallGeometryOfScriptWindow();

  InterfaceToGlobScript* interObj = new InterfaceToGlobScript(this, Detector, EventsDataHub); //deleted by the GenScriptWindow
  GenScriptWindow->SetInterfaceObject(interObj);

  InterfaceToConfig* conf = new InterfaceToConfig(this);
  GenScriptWindow->SetInterfaceObject(conf, "config");

  InterfaceToMinimizerScript* mini = new InterfaceToMinimizerScript(this);
  GenScriptWindow->SetInterfaceObject(mini, "mini");  //mini should be before sim to handle abort correctly

  InterfaceToData* dat = new InterfaceToData(this, Detector, EventsDataHub);
  GenScriptWindow->SetInterfaceObject(dat, "data");

  InterfaceToSim* sim = new InterfaceToSim(this, Detector, EventsDataHub);
  GenScriptWindow->SetInterfaceObject(sim, "sim");

  InterfaceToReconstructor* rec = new InterfaceToReconstructor(this, EventsDataHub);
  GenScriptWindow->SetInterfaceObject(rec, "rec");

  InterfaceToLRF* lrf = new InterfaceToLRF(this);
  GenScriptWindow->SetInterfaceObject(lrf, "lrf");

  InterfaceToGeoWin* geowin = new InterfaceToGeoWin(this, Detector);
  GenScriptWindow->SetInterfaceObject(geowin, "geowin");

  InterfaceToGraphWin* grwin = new InterfaceToGraphWin(this);
  GenScriptWindow->SetInterfaceObject(grwin, "grwin");

  InterfaceToTexter* txt = new InterfaceToTexter();
  GenScriptWindow->SetInterfaceObject(txt, "msg");

  InterfaceToInteractionScript* depo = new InterfaceToInteractionScript(this, EventsDataHub);
  GenScriptWindow->SetInterfaceObject(depo, "depo");

  InterfaceToAddObjScript* geo = new InterfaceToAddObjScript(this);
  GenScriptWindow->SetInterfaceObject(geo, "geo");

  InterfaceToGraphs* graph = new InterfaceToGraphs(this);
  GenScriptWindow->SetInterfaceObject(graph, "graph");

  InterfaceToHistD* hist = new InterfaceToHistD(this);
  GenScriptWindow->SetInterfaceObject(hist, "hist");

  GenScriptWindow->SetStarterDir(GlobSet->LibScripts, GlobSet->LastOpenDir, GlobSet->ExamplesDir);
  GenScriptWindow->SetExample("#Load ScriptExample_fit.txt"); //has to be after SetStarterDir
  GenScriptWindow->SetShowEvaluationResult(true);
  GenScriptWindow->SetTitle("ANTS2 script mode");
  GenScriptWindow->SetScript(&GlobSet->GlobScript);

  connect(GenScriptWindow, SIGNAL(RequestDraw(TObject*,QString,bool)), GraphWindow, SLOT(DrawStrOpt(TObject*,QString,bool)));

  GenScriptWindow->show();
}
