//ANTS2
#include "reconstructionwindow.h"
#include "ui_reconstructionwindow.h"
#include "mainwindow.h"
#include "genericscriptwindowclass.h"
#include "scriptfilterclass.h"
#include "globalsettingsclass.h"
#include "detectorclass.h"

void ReconstructionWindow::on_pbScriptFilter_clicked()
{
  MW->extractGeometryOfScriptWindow();
  if (MW->GenScriptWindow) delete MW->GenScriptWindow;
  MW->GenScriptWindow = new GenericScriptWindowClass();
  MW->recallGeometryOfScriptWindow();

  InterfaceToScriptFilter* interObj = new InterfaceToScriptFilter(EventsDataHub, MW->Detector->PMs); //deleted by the GenScriptWindow
  MW->GenScriptWindow->SetInterfaceObject(interObj);

  MW->GenScriptWindow->SetExample(
  "var events = countEvents()\n"
  "      \n"
  "for (var i=0; i<events; i++)\n"
  " {\n"
  "   setGood(i)\n"
  "      \n"
  "   if (xScan(i)<-5 || xScan(i)>10) setFail(i)\n"
  "   if (yScan(i)<-0 || yScan(i)>5) setFail(i)\n"
  "   if (energy(i)>1) setFail(i)\n"
  " }\n\n"
  " countGoodEvents()\n"
  );

  MW->GenScriptWindow->SetShowEvaluationResult(true);
  MW->GenScriptWindow->SetTitle("Custom filter script");
  MW->GenScriptWindow->SetScript(&FilterScript);
  MW->GenScriptWindow->SetStarterDir(MW->GlobSet->LibScripts);

  connect(MW->GenScriptWindow, SIGNAL(success(QString)), this, SLOT(ShowStatistics()));

  MW->GenScriptWindow->show();
}
