#ifndef EXAMPLESWINDOW_H
#define EXAMPLESWINDOW_H

#include <QMainWindow>
#include "classes.h"

class MainWindow;

namespace Ui {
  class ExamplesWindow;
}

class ExamplesWindow : public QMainWindow
{
  Q_OBJECT
  
public:
  explicit ExamplesWindow(QWidget* parent, MainWindow *mw);
  ~ExamplesWindow();

  bool SaveAllConfig(QString fileName, bool DetConstructor = true, bool SimSettings = true, bool ReconstrSettings = true);
  bool SaveAllConfig(QJsonObject &json, bool DetConstructor = true, bool SimSettings = true, bool ReconstrSettings = true);
  bool LoadAllConfig(QString fileName, bool DetConstructor = true, bool SimSettings = true, bool ReconstrSettings = true, QJsonObject *jsout = 0);
  bool LoadAllConfig(QJsonObject &json, bool DetConstructor = true, bool SimSettings = true, bool ReconstrSettings = true, bool fKeepData = false);

  void QuickSave(); //save configuration to LAST/QuickSave.conf
  void QuickLoad();

  void setShowExamplesOnStartStatus(bool show);

private slots:
  void on_cbDoNotShowExamplesOnStart_toggled(bool checked);

  void on_lwMainType_currentRowChanged(int currentRow);

  void on_lwSubType_currentRowChanged(int currentRow);

  void on_lwExample_currentRowChanged(int currentRow);

  void on_pbLoadExample_clicked();

  void on_lwExample_doubleClicked(const QModelIndex &index);

  void on_pbSaveSessings_clicked();

  void on_pbQuickSave_clicked();

  void on_pbLoadSettings_clicked();

  void on_pbQuickLoad_clicked();

protected:
    bool event(QEvent *event);

private:
  Ui::ExamplesWindow *ui;
  MainWindow* MW;

  int MainPointer, SubPointer, ExamplePointer;
  QVector<QString> MainTypeNames;
  QVector< QVector <QString> > SubTypeNames;

  QVector<DetectorExampleStructure> Examples;
  QVector<int> ListedExamples; //to find the proper one from the list index

  void BuildExampleRecord();
  void AddNewMainType(QString name);
  void AddNewSubType(QString maintype, QString subtype);
  void AddNewExample(QString maintype, QString subtype, QString filename, QString description);

};

#endif // EXAMPLESWINDOW_H
