#include "guiutils.h"
#include <QFont>
#include <QMainWindow>

#include <QLineEdit>


void SetWindowFont(QMainWindow *w, int ptsize)
{
    QFont font = w->font();
    font.setPointSize(ptsize);
    w->setFont(font);
}

QIcon createColorCircleIcon(QSize size, Qt::GlobalColor color)
{
  QPixmap pm(size.width()-2, size.height()-2);
  pm.fill(Qt::transparent);
  QPainter b(&pm);
  b.setBrush(QBrush(color));
  b.drawEllipse(0, 0, size.width()-3, size.width()-3);
  return QIcon(pm);
}

TableDoubleDelegateClass::TableDoubleDelegateClass(QObject *parent)  : QItemDelegate(parent)
{
}

QWidget *TableDoubleDelegateClass::createEditor(QWidget *parent, const QStyleOptionViewItem &, const QModelIndex &) const
{
  QLineEdit *editor = new QLineEdit(parent);
  editor->setValidator(new QDoubleValidator(editor));
  editor->setEnabled(true);
  return editor;
}


void myQGraphicsView::mouseMoveEvent(QMouseEvent *event)
{
  MousePosition = this->mapToScene(event->pos());
  //MousePosition = event->pos();
//  qDebug() << MousePosition << this->mapToScene(event->pos());
  emit MouseMovedSignal(&MousePosition);
  QGraphicsView::mouseMoveEvent(event);
}
