#ifndef GUIUTILS_H
#define GUIUTILS_H

//#include <QMainWindow>
//#include <QtGlobal>
#include <QtGui>
class QMainWindow;
#include <QGraphicsScene>
#include <QGraphicsView>
#include <QItemDelegate>

class myQGraphicsView : public QGraphicsView
{
   Q_OBJECT
public:
  myQGraphicsView ( QWidget * parent = 0 ) : QGraphicsView(parent) {CursorMode = 0;}
  myQGraphicsView ( QGraphicsScene * scene, QWidget * parent = 0 ) : QGraphicsView(scene,parent) {CursorMode = 0;}
  void setCursorMode(int mode) {CursorMode = mode;}
signals:
  void MouseMovedSignal(QPointF *Pos);
protected:
  virtual void wheelEvent ( QWheelEvent * event )
  {
    if(event->delta() > 0)
    {
        scale(1.1, 1.1);
    }
    else
    {
        scale(1.0/1.1, 1.0/1.1);
    }
  }
  void mouseMoveEvent(QMouseEvent *event);
  void enterEvent(QEvent *event) {QGraphicsView::enterEvent(event); if (CursorMode == 1) viewport()->setCursor(Qt::CrossCursor);}
  void mousePressEvent(QMouseEvent *event){QGraphicsView::mousePressEvent(event); if (CursorMode == 1) viewport()->setCursor(Qt::CrossCursor);}
  void mouseReleaseEvent(QMouseEvent *event){QGraphicsView::mouseReleaseEvent(event); if (CursorMode == 1) viewport()->setCursor(Qt::CrossCursor);}


private:
  QPointF MousePosition;
  int CursorMode;
};

class TableDoubleDelegateClass : public QItemDelegate
{
  public:
    TableDoubleDelegateClass(QObject *parent = 0);

    QWidget* createEditor(QWidget *parent,
                          const QStyleOptionViewItem &/* option */,
                          const QModelIndex &/* index */) const;
};

void SetWindowFont(QMainWindow *w, int ptsize);
QIcon createColorCircleIcon(QSize size, Qt::GlobalColor color);

#endif // GUIUTILS_H
