#ifndef HIGHLIGHTERCLASS_H
#define HIGHLIGHTERCLASS_H

#include <QSyntaxHighlighter>

class HighlighterClass : public QSyntaxHighlighter
{
    Q_OBJECT
public:
    HighlighterClass(QTextDocument *parent = 0);

    void setCustomCommands(QStringList functions, QStringList constants);

protected:
    void highlightBlock(const QString &text);

private:
    struct HighlightingRule
      {
        QRegExp pattern;
        QTextCharFormat format;
      };
    QVector<HighlightingRule> highlightingRules;

    QRegExp commentStartExpression;
    QRegExp commentEndExpression;

    QTextCharFormat keywordFormat;
    QTextCharFormat customKeywordFormat;
//    QTextCharFormat classFormat;
    QTextCharFormat singleLineCommentFormat;
    QTextCharFormat multiLineCommentFormat;
    QTextCharFormat quotationFormat;
    QTextCharFormat charFormat;
//    QTextCharFormat functionFormat;


};

#endif // HIGHLIGHTERCLASS_H
