#ifndef WINDOWNAVIGATORCLASS_H
#define WINDOWNAVIGATORCLASS_H

#include <QMainWindow>

class MainWindow;

#ifdef Q_OS_WIN32
#include <QWinTaskbarButton>
#include <QWinTaskbarProgress>
#endif

namespace Ui {
  class WindowNavigatorClass;
}

class QTime;

class WindowNavigatorClass : public QMainWindow
{
  Q_OBJECT
  
public:
  explicit WindowNavigatorClass(QWidget *parent, MainWindow *mw);
  ~WindowNavigatorClass();

  //void setLastProcessedWindow(QString str){LastProcessedWindow = str;}
  void setProgress(int percent);

  void HideWindowTriggered(QString w);
  void ShowWindowTriggered(QString w);

  void ResetAllProgressBars();

  bool isMainChangeExplicitlyRequested() {return MainChangeExplicitlyRequested;}
  void TriggerHideButton();
  void TriggerShowButton();

  //global control :)
  void BusyOn();
  void BusyOff(bool fShowTime = true);

#ifdef Q_OS_WIN32
  QWinTaskbarButton *taskButton;
  QWinTaskbarProgress *taskProgress;
#endif

  
public slots:
  void SetupWindowsTaskbar();
  void on_pbMaxAll_clicked();

private slots:


   void on_pbMinAll_clicked();

   void on_pbMain_clicked();

   void on_pbRecon_clicked();

   void on_pbOut_clicked();

   void on_pbLRF_clicked();

   void on_pbGeometry_clicked();

   void on_pbGraph_clicked();

   void on_pbMaterials_clicked();

   void on_pbExamples_clicked();

   void on_pbGain_clicked();

protected:
    void closeEvent(QCloseEvent *);

private:
  Ui::WindowNavigatorClass *ui;
  MainWindow* MW;

  QTime* time;

  QString LastProcessedWindow;
  bool DisableBSupdate;
  bool MainOn, ReconOn, OutOn, LRFon, MatOn, ExamplesOn, GeometryOn, GraphOn, GainOn;

  bool MainChangeExplicitlyRequested;
};

#endif // WINDOWNAVIGATORCLASS_H
