//ANTS2
#include "detectorclass.h"
#include "eventsdataclass.h"
#include "reconstructionmanagerclass.h"
#include "mainwindow.h"
#include "exampleswindow.h"
#include "scriptmode.h"
#include "tmpobjhubclass.h"

//Qt
#include <QApplication>
#include <QLocale>
#include <QtGui>
#include <TThread.h>

//Root
#include "TApplication.h"

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);
    QLocale::setDefault(QLocale("en_US"));

    int rootargc=1;
    char *rootargv[] = {(char*)"qqq"};
    TApplication RootApp("My ROOT", &rootargc, rootargv);
    //qDebug() << "___> Root App created";
    TThread::Initialize();
    //qDebug() << "___> TThread initialized";
    DetectorClass Detector;
    //qDebug() << "___> Detector created";
    EventsDataClass EventsDataHub;
    //qDebug() << "___> EventsDataHub created";
    ReconstructionManagerClass ReconstructionManager(&EventsDataHub, &Detector);
    //qDebug() << "___> Reconstruction manager created";
    TmpObjHubClass TmpHub;

    batcher = new ScriptMode(&Detector, &EventsDataHub, &ReconstructionManager);
    if(argc == 1)
    {
        MainWindow w(&Detector, &EventsDataHub, &RootApp, &ReconstructionManager, &TmpHub);
        //GUI application
        w.show();

        //overrides the saved status of examples window
        if (w.ShowExamplesOnStart)
        {
            w.ELwindow->show();
            w.ELwindow->raise();//making sure examples window is on top
        }
        else w.ELwindow->hide();

        //enter cycle
        return a.exec();
    }
    else
    {
        batcher->run(QCoreApplication::arguments().mid(1));
        return 0;
    }
}
