#ifndef DETECTIONSTATISTICSCLASS_H
#define DETECTIONSTATISTICSCLASS_H

#include "TString.h"
class TH1I;
class TH1D;

class DetectionStatisticsClass
{
public:
    DetectionStatisticsClass(const TString nameID = "");
    ~DetectionStatisticsClass();

    void initialize(int nBins = 0); //0 - default (101) or previously set value will be used
    bool isEmpty();

    void registerWave(int iWave);
    void registerTime(double Time);
    void registerAngle(double CosAngle);
    void registerNumTrans(int NumTransitions);

    //photon loss statistics
    long Absorbed, OverrideLoss, HitPM, HitDummy, Escaped, LossOnGrid, TracingSkipped, MaxCyclesReached;
    void AppendPhotonLossStat(const DetectionStatisticsClass *from);

    //read-outs
    TH1I* getWaveSpectrum() {return WaveSpectrum;}
    TH1D* getTimeSpectrum() {return TimeSpectrum;}
    TH1I* getCosAngleSpectrum() {return CosAngleSpectrum;}
    TH1I* getTransitionSpectrum() {return TransitionSpectrum;}

private:
    TH1I* WaveSpectrum;
    TH1D* TimeSpectrum;
    TH1I* CosAngleSpectrum;
    TH1I* TransitionSpectrum;

    int numBins;
    TString NameID;
};

#endif // DETECTIONSTATISTICSCLASS_H
