#ifndef PHOTON_GENERATOR_H
#define PHOTON_GENERATOR_H

#include <QObject>
#include <QVector>

//own
#include "classes.h"
#include "functions.h"
#include "generalsimsettings.h"

class TRandom2;
struct One_Photon;
struct MaterialStructure;
class MaterialCollectionClass;

class Photon_Generator : public QObject
{
    Q_OBJECT
public:
    explicit Photon_Generator(TRandom2* RandomGenerator, MaterialCollectionClass* materialCollection, QObject *parent = 0);
    ~Photon_Generator();

    //usage
    void GenerateDirectionPrimary(One_Photon *Photon);
    void GenerateDirectionSecondary(One_Photon *Photon);
    void GenerateWaveTime(One_Photon *Photon, int materialId);

    //config and requests
    //void setWavelengthResolved(bool flag) {WavelengthResolved = flag;}
    //void setTimeResolved(bool flag) {TimeResolved = flag;}
    //void setWaveFrom(double from) {WaveFrom = from;}
    //void setWaveStep(double step) {WaveStep = step;}
    //void setSecScintDirectionType(int val) {SecScintDirectionType = val;}
    //bool isSecScintDistribution() {if (SecScintThetaDistribution) return true; else return false;}
    //void setSecScintThetaDistribution(TH1D* hist) {SecScintThetaDistribution = hist;}
    //void deleteSecScintThetaDistribution();
    //TH1D* getSecScintThetaDistribution() {return SecScintThetaDistribution;}
      //configure all
    void configure(const GeneralSimSettings *simSet) {SimSet = simSet;}//bool fWave, bool fTime, double waveFrom, double waveStep, int secScintType, TH1D *secThetaDistr = 0);

signals:
    
public slots:

private:
    TRandom2* RandGen;
    MaterialCollectionClass* MaterialCollection;

    const GeneralSimSettings* SimSet;
    /*
    bool WavelengthResolved;
    bool TimeResolved;
    double WaveFrom, WaveStep;
    int SecScintDirectionType; //0 - 4Pi, 1 - 2Pi(up), 2 - 2Pi(down), 3 - custom
    TH1D* SecScintThetaDistribution;
    */
};

#endif // PHOTON_GENERATOR_H
