#ifndef S2_GENERATOR_H
#define S2_GENERATOR_H

#include <QObject>

//own
#include "classes.h"

//struct EnergyDepositionStructure;
struct EnergyDepositionCell;
class Photon_Tracker;
class Photon_Generator;
class TRandom2;
class TGeoManager;
struct MaterialStructure;
class MaterialCollectionClass;

class S2_Generator : public QObject
{
    Q_OBJECT
public:
    explicit S2_Generator(Photon_Generator* photonGenerator, Photon_Tracker* photonTracker,  QVector<EnergyDepositionCell*>* energyVector, TRandom2 *RandomGenerator, TGeoManager* geoManager, MaterialCollectionClass* materialCollection, QVector<GeneratedPhotonsHistoryStructure>* PhotonsHistory, QObject *parent = 0);   //

    void UpdateGeoManager(TGeoManager* NewGeoManager) {GeoManager = NewGeoManager;}
    
    bool Generate(); //uses EnergyVector as the input parameter

    void setDoTextLog(bool flag){DoTextLog = flag;}
    void setOnlySecondary(bool flag){OnlySecondary = flag;} //determines how photon log is filled

signals:
    
public slots:

private:
   // EnergyDepositionStructure* EnergyVector;
    QVector<EnergyDepositionCell*>* EnergyVector;
    Photon_Generator* PhotonGenerator;
    Photon_Tracker* PhotonTracker;
    TRandom2* RandGen;
    TGeoManager* GeoManager;
    MaterialCollectionClass* MaterialCollection;
    QVector<GeneratedPhotonsHistoryStructure>* GeneratedPhotonsHistory;

    bool DoTextLog;
    bool OnlySecondary;

};

#endif // S2_GENERATOR_H
