#ifndef SCATTERONMETAL_H
#define SCATTERONMETAL_H

#include "opticaloverrideclass.h"
#include "materialcollectionclass.h"

//Qt
#include <QJsonObject>

//ROOT
#include "TRandom2.h"

class ScatterOnMetal : public OpticalOverrideClass
{
public:    
  ScatterOnMetal(MaterialCollectionClass* MatCollection, int MatFrom, int MatTo)
    : OpticalOverrideClass(MatCollection, MatFrom, MatTo) {}
  virtual ~ScatterOnMetal() {}

  virtual OpticalOverrideResultEnum calculate(TRandom2* RandGen, double* PhotonDir, const double* NormalVector, int iWave); //unitary vectors! iWave = -1 if not wavelength-resolved

  virtual void printConfiguration(int iWave);
  virtual QString getType() const {return "DielectricToMetal";}
  virtual QString getReportLine();

  // save/load config is not used for this type!
  virtual bool writeToJson(QJsonObject &json);
  virtual bool readFromJson(QJsonObject &json);

  //data
  double RealN, ImaginaryN;
private:
  double calculateReflectivity(double CosTheta, double RealN, double ImaginaryN);

};

#endif // SCATTERONMETAL_H
