#ifndef CONFIGSCRIPTINTERFACE_H
#define CONFIGSCRIPTINTERFACE_H

#include <QObject>
#include <QJsonObject>
#include <QVariant>

class ConfigScriptInterface : public QObject
{
Q_OBJECT
public:
    static const QChar pathSep;

    ConfigScriptInterface();
    const QJsonObject &getConfig() const { return config; }
    QJsonObject &getConfig() { return config; }

    bool pleaseRemakeDetector() const { return fRemakeDetector; }
    void weRemadeDetector() { this->fRemakeDetector = false; }

public slots:
    QString get(QString setting);
    bool loadFile(QString filename);
    bool saveFile(QString filename);
    bool set(QString setting, QVariant value);
    bool cd(QString path);
    QString pwd();
    void clear();
    QStringList normalizepath(QString path);

private:
    QJsonObject config;
    QString cwd;
    bool fRemakeDetector;
};
#endif
