#include "functions.h"

#include <QDebug>
#include <QFile>
#include <QString>
#include <QJsonDocument>

namespace Functions {
  QByteArray readAllFile(const QString &filename)
  {
    QFile file(filename);
    if (!file.open(QIODevice::ReadOnly))
    {
      qDebug()<<"Can't open file"<<filename;
      return QByteArray();
    }

    QByteArray saveData = file.readAll();
    file.close();
    return saveData;
  }

  bool saveJson(const QString &filename, const QJsonObject &json)
  {
    QFile saveFile(filename);
    if (!saveFile.open(QIODevice::WriteOnly))
    {
      qDebug()<<"Can't open file"<<filename<<"to save json!";
      return false;
    }

    QJsonDocument saveDoc(json);
    saveFile.write(saveDoc.toJson());
    saveFile.close();
    return true;
  }
}
