#ifndef SCRIPTMINIMIZER_H
#define SCRIPTMINIMIZER_H

#include "scriptinterfaces.h"

#include <QObject>
#include <QVector>

class MainWindow;

class InterfaceToMinimizerScript : public BaseInterfaceClass
{
  Q_OBJECT

public:
  InterfaceToMinimizerScript(MainWindow* MW) : MW(MW) {}
  ~InterfaceToMinimizerScript() {}

  virtual void ForceStop();

public slots:
  //void AbortMinimization();
  void Clear();
  void SetFunctorName(QString name);
  void AddVariable(QString name, double start, double step, double min, double max);
  void ModifyVariable(int varNumber, double start, double step, double min, double max);
  QString Run();

private:
  MainWindow* MW;

  QVector<QString> Name;
  QVector<double> Start, Step, Min, Max;
  QString FunctorName;


  void abort(QString message = "Aborted!") {emit AbortScriptEvaluation(message);}

signals:
  void AbortScriptEvaluation(QString);

};

#endif // SCRIPTMINIMIZER_H
