#ifndef SCRIPTMODE_H
#define SCRIPTMODE_H

class DetectorClass;
class EventsDataClass;
class ReconstructionManagerClass;
class SimulationManager;
class GenericScriptWindowClass;

class QString;
class QStringList;
class QScriptEngine;

class ScriptMode
{
public:
    ScriptMode(DetectorClass *detector, EventsDataClass *eventsHub, ReconstructionManagerClass *reconMan);
    ~ScriptMode();
    void run(const QStringList &args); //Intended to be called from main(), without external perturbations
    void attachToWindow(GenericScriptWindowClass *scriptWindow);

private:
    DetectorClass *detector;
    EventsDataClass *eventsHub;
    ReconstructionManagerClass *reconMan;
    SimulationManager *simMan;

    friend class MainScriptInterface;
};

extern ScriptMode *batcher;

#endif // SCRIPTMODE_H
